
// -- This file was mechanically generated: Do not edit! -- //

package sun.nio.cs;

import java.nio.charset.Charset;

/**
 * Explicit charset provider class for standard charsets.
 *
 * @author unascribed
 * @author Ulf Zibis, Cologne <Ulf.Zibis @ CoSoCo.de>
 */
public class StandardCharsets extends FastCharsetProvider {

    private static final Charset US_ASCII = new US_ASCII("US-ASCII",
            "iso-ir-6",
            "ANSI_X3.4-1986",
            "ISO_646.irv:1991",
            "ASCII",
            "ISO646-US",
            "us",
            "IBM367",
            "cp367",
            "csASCII",
            "default",
            "646",
            "iso_646.irv:1983",
            "ANSI_X3.4-1968",
            "ascii7"
    );

    private static final Charset UTF_8 = new UTF_8("UTF-8",
            "UTF8",
            "unicode-1-1-utf-8"
    );

    private static final Charset UTF_16 = new UTF_16("UTF-16",
            "UTF_16",
            "utf16",
            "unicode",
            "UnicodeBig"
    );

    private static final Charset UTF_16BE = new UTF_16BE("UTF-16BE",
            "UTF_16BE",
            "ISO-10646-UCS-2",
            "X-UTF-16BE",
            "UnicodeBigUnmarked"
    );

    private static final Charset UTF_16LE = new UTF_16LE("UTF-16LE",
            "UTF_16LE",
            "X-UTF-16LE",
            "UnicodeLittleUnmarked"
    );

    private static final Charset UTF_16LE_BOM = new UTF_16LE_BOM("x-UTF-16LE-BOM",
            "UnicodeLittle"
    );

    private static final Charset UTF_32 = new UTF_32("UTF-32",
            "UTF_32",
            "UTF32"
    );

    private static final Charset UTF_32LE = new UTF_32LE("UTF-32LE",
            "UTF_32LE",
            "X-UTF-32LE"
    );

    private static final Charset UTF_32BE = new UTF_32BE("UTF-32BE",
            "UTF_32BE",
            "X-UTF-32BE"
    );

    private static final Charset UTF_32LE_BOM = new UTF_32LE_BOM("X-UTF-32LE-BOM",
            "UTF_32LE_BOM",
            "UTF-32LE-BOM"
    );

    private static final Charset UTF_32BE_BOM = new UTF_32BE_BOM("X-UTF-32BE-BOM",
            "UTF_32BE_BOM",
            "UTF-32BE-BOM"
    );

    private static final Charset ISO_8859_1 = new ISO_8859_1("ISO-8859-1",
            "iso-ir-100",
            "ISO_8859-1",
            "latin1",
            "l1",
            "IBM819",
            "cp819",
            "csISOLatin1",
            "819",
            "IBM-819",
            "ISO8859_1",
            "ISO_8859-1:1987",
            "ISO_8859_1",
            "8859_1",
            "ISO8859-1"
    );

    private static final Charset MS1252 = new FastCharset("MS1252", "windows-1252",
            "cp1252",
            "cp5348"
    );

//    static final String[] aliases_MS1252 = new String[] {
//            "cp1252",
//            "cp5348"
//    };
//    private static final Charset MS1252 = new MS1252();

    private static final int LENGTH = 13;

    public StandardCharsets() {
        super(LENGTH, new Cache());
    }


    private static final class Cache
        extends sun.util.PreHashedMap<Charset>
    {

        private static final int ROWS = 64;
        private static final int SIZE = 67;
        private static final int SHIFT = 0;
        private static final int MASK = 0x3f;

        private Cache() {
            super(ROWS, SIZE, SHIFT, MASK);
        }

        protected void init(Object[] ht) {
            ht[0] = new Object[] { "ISO_646.IRV:1983", US_ASCII };
            ht[1] = new Object[] { "CSASCII", US_ASCII };
            ht[2] = new Object[] { "CSISOLATIN1", ISO_8859_1,
                         new Object[] { "US-ASCII", US_ASCII } };
            ht[3] = new Object[] { "X-UTF-16BE", UTF_16BE,
                         new Object[] { "UNICODEBIG", UTF_16 } };
            ht[6] = new Object[] { "X-UTF-32LE-BOM", UTF_32LE_BOM };
            ht[8] = new Object[] { "UNICODEBIGUNMARKED", UTF_16BE };
            ht[12] = new Object[] { "IBM819", ISO_8859_1,
                         new Object[] { "X-UTF-16LE-BOM", UTF_16LE_BOM } };
            ht[13] = new Object[] { "LATIN1", ISO_8859_1 };
            ht[15] = new Object[] { "CP5348", MS1252 };
            ht[16] = new Object[] { "X-UTF-32BE-BOM", UTF_32BE_BOM,
                         new Object[] { "UTF_32LE", UTF_32LE } };
            ht[17] = new Object[] { "UTF8", UTF_8 };
            ht[19] = new Object[] { "CP819", ISO_8859_1 };
            ht[22] = new Object[] { "8859_1", ISO_8859_1,
                         new Object[] { "UTF_16LE", UTF_16LE,
                             new Object[] { "ANSI_X3.4-1986", US_ASCII } } };
            ht[23] = new Object[] { "UTF_32", UTF_32 };
            ht[26] = new Object[] { "UTF_32BE", UTF_32BE,
                         new Object[] { "ANSI_X3.4-1968", US_ASCII } };
            ht[29] = new Object[] { "UTF_16", UTF_16,
                         new Object[] { "ISO_646.IRV:1991", US_ASCII } };
            ht[30] = new Object[] { "UTF-32LE", UTF_32LE,
                         new Object[] { "US", US_ASCII } };
            ht[32] = new Object[] { "819", ISO_8859_1,
                         new Object[] { "UTF_16BE", UTF_16BE,
                             new Object[] { "IBM367", US_ASCII } } };
            ht[33] = new Object[] { "DEFAULT", US_ASCII };
            ht[34] = new Object[] { "ISO_8859-1", ISO_8859_1 };
            ht[36] = new Object[] { "UTF-16LE", UTF_16LE };
            ht[37] = new Object[] { "L1", ISO_8859_1,
                         new Object[] { "UTF-32", UTF_32 } };
            ht[38] = new Object[] { "UTF32", UTF_32,
                         new Object[] { "ASCII7", US_ASCII } };
            ht[39] = new Object[] { "IBM-819", ISO_8859_1,
                         new Object[] { "CP367", US_ASCII } };
            ht[40] = new Object[] { "WINDOWS-1252", MS1252,
                         new Object[] { "UTF-32BE", UTF_32BE } };
            ht[42] = new Object[] { "UNICODE-1-1-UTF-8", UTF_8 };
            ht[43] = new Object[] { "CP1252", MS1252,
                         new Object[] { "UTF-16", UTF_16 } };
            ht[44] = new Object[] { "UTF16", UTF_16 };
            ht[45] = new Object[] { "ISO8859-1", ISO_8859_1 };
            ht[46] = new Object[] { "ISO-10646-UCS-2", UTF_16BE,
                         new Object[] { "UTF-16BE", UTF_16BE } };
            ht[48] = new Object[] { "ISO_8859_1", ISO_8859_1,
                         new Object[] { "ISO-8859-1", ISO_8859_1 } };
            ht[49] = new Object[] { "UTF-32LE-BOM", UTF_32LE_BOM,
                         new Object[] { "UTF_32LE_BOM", UTF_32LE_BOM,
                             new Object[] { "ASCII", US_ASCII } } };
            ht[50] = new Object[] { "UTF-8", UTF_8 };
            ht[51] = new Object[] { "X-UTF-32LE", UTF_32LE,
                         new Object[] { "UNICODELITTLE", UTF_16LE_BOM } };
            ht[53] = new Object[] { "ISO-IR-100", ISO_8859_1 };
            ht[56] = new Object[] { "UNICODELITTLEUNMARKED", UTF_16LE,
                         new Object[] { "646", US_ASCII,
                             new Object[] { "ISO646-US", US_ASCII } } };
            ht[57] = new Object[] { "X-UTF-16LE", UTF_16LE };
            ht[58] = new Object[] { "ISO-IR-6", US_ASCII };
            ht[59] = new Object[] { "ISO8859_1", ISO_8859_1,
                         new Object[] { "UTF-32BE-BOM", UTF_32BE_BOM,
                             new Object[] { "UTF_32BE_BOM", UTF_32BE_BOM } } };
            ht[61] = new Object[] { "X-UTF-32BE", UTF_32BE,
                         new Object[] { "UNICODE", UTF_16 } };
            ht[63] = new Object[] { "ISO_8859-1:1987", ISO_8859_1 };
        }

    }

}
